@testable import MatomoTracker

extension Event {
    static func fixture(
        uuid: UUID = UUID(),
        siteId: String = "fixture_siteId",
        visitor: Visitor = .fixture(),
        session: Session = .fixture(),
        isCustomAction: Bool = true,
        date: Date = Date(),
        url: URL = URL(string: "http://spec_url")!,
        actionName: [String] = [],
        language: String = "spec_language",
        isNewSession: Bool = true,
        referer: URL? = nil,
        customVariables: [CustomVariable] = [],
        eventCategory: String? = nil,
        eventAction: String? = nil,
        eventName: String? = nil,
        eventValue: Float? =  nil,
        campaignName: String? =  nil,
        campaignKeyword: String? =  nil,
        searchQuery: String? =  nil,
        searchCategory: String? =  nil,
        searchResultsCount: Int? =  nil,
        dimensions: [CustomDimension] = [],
        customTrackingParameters: [String:String] = [:],
        contentName: String? = nil,
        contentPiece: String? = nil,
        contentTarget: String? = nil,
        contentInteraction: String? = nil,
        goalId: Int? = nil,
        revenue: Float? = nil,
        orderId: String? = nil,
        orderItems: [OrderItem] = [],
        orderRevenue: Float? = nil,
        orderSubTotal: Float? = nil,
        orderTax: Float? = nil,
        orderShippingCost: Float? = nil,
        orderDiscount: Float? = nil,
        orderLastDate: Date? = nil) -> Event {
        Event(
            uuid: uuid,
            siteId: siteId,
            visitor: visitor,
            session: session,
            isCustomAction: isCustomAction,
            date: date,
            url: url,
            actionName: actionName,
            language: language,
            isNewSession: isNewSession,
            referer: referer,
            customVariables: customVariables,
            eventCategory: eventCategory,
            eventAction: eventAction,
            eventName: eventName,
            eventValue: eventValue,
            campaignName: campaignName,
            campaignKeyword: campaignKeyword,
            searchQuery: searchQuery,
            searchCategory: searchCategory,
            searchResultsCount: searchResultsCount,
            dimensions: dimensions,
            customTrackingParameters: customTrackingParameters,
            contentName: contentName,
            contentPiece: contentPiece,
            contentTarget: contentTarget,
            contentInteraction: contentInteraction,
            goalId: goalId,
            revenue: revenue,
            orderId: orderId,
            orderItems: orderItems,
            orderRevenue: orderRevenue,
            orderSubTotal: orderSubTotal,
            orderTax: orderTax,
            orderShippingCost: orderShippingCost,
            orderDiscount: orderDiscount,
            orderLastDate: orderLastDate)
    }
}
